/* Loading
===============================*/
paceOptions = {
    ajax: true,
    document: true,
    eventLag: false,
};
Pace.on("done", function () {
    $(".preloader p")
        .delay(200)
        .animate({ top: "40%", opacity: "0" }, 1000, $.bez([0.19, 1, 0.22, 1]));
    $(".pace")
        .delay(500)
        .animate({ width: "100%" }, 1000, $.bez([0.19, 1, 0.22, 1]))
        .animate({ opacity: "0" }, 10, $.bez([0.19, 1, 0.22, 1]));
    $(".preloader")
        .delay(1700)
        .animate({ top: "-100%" }, 2000, $.bez([0.19, 1, 0.22, 1]));
    $("body")
        .delay(2000)
        .css({ "overflow-y": "visible" }, 10, $.bez([0.19, 1, 0.22, 1]));
    $(".main .intro h3")
        .delay(2500)
        .animate({ top: "0", opacity: "1" }, 10, $.bez([0.19, 1, 0.22, 1]));
    $(".main .intro p")
        .delay(2800)
        .animate({ top: "0", opacity: "1" }, 10, $.bez([0.19, 1, 0.22, 1]));
    $(".main .intro p::before")
        .delay(3100)
        .animate({ top: "0", opacity: "1" }, 10, $.bez([0.19, 1, 0.22, 1]));
});

/* Animations
==========================*/
$(window).on("load", function () {
    "use strict";
    AOS.init({
        offset: 20,
        duration: 700,
        easing: "ease-in-out",
    });
});

/* Header Move
================================*/
$(window).scroll(function () {
    let scroll = $(window).scrollTop();
    if (scroll >= 60) {
        $("header").addClass("move");
    } else {
        $("header").removeClass("move");
    }

});

/* testimonials
=================================*/
$(".testimonials_slider").owlCarousel({
    loop: true,
    nav: true,
    dots: false,
    smartSpeed: 2800,
    autoplay:true,
    autoplayHoverPause: true,
    navText:["<div class='fa fa-arrow-right'></div>","<div class='fa fa-arrow-left'></div>"],
    margin: 35,
    autoplay: false,
    items: 1
});
$(".clients_slider").owlCarousel({
    loop: true,
    nav: false,
    dots: false,
    autoplay: true,
    smartSpeed: 2800,
    autoplayHoverPause: false,
    navText:["<div class='fa fa-arrow-right'></div>","<div class='fa fa-arrow-left'></div>"],
    margin: 35,
    autoplay: false,
    responsive: {
        0: {
            items: 2,
            margin: 0
        },
        576: {
            items: 4,
            margin: 0
        },
        768: {
            items: 5,
            margin: 5
        },
        992: {
            items: 5
        },
        1440: {
            items: 6
        }
    }
});
/* Canvas
================================*/
const canvas = document.getElementById("canvas1");
const ctx = canvas.getContext("2d");
canvas.width = window.innerWidth;
canvas.height = window.innerHeight;
let gradient = ctx.createRadialGradient(
    canvas.width / 2,
    canvas.height / 2,
    100,
    canvas.width / 2,
    canvas.height / 2,
    canvas.width / 2
);
gradient.addColorStop(0, "#fff6");
gradient.addColorStop(1, "#fff8");

class Symbol {
    constructor(x, y, fontSize, canvasHeight) {
        this.characters =
            "inzox";
        this.x = x;
        this.y = y;
        this.fontSize = fontSize;
        this.text = "";
        this.canvasHeight = canvasHeight;
    }

    draw(context) {
        this.text = this.characters.charAt(
            Math.floor(Math.random() * this.characters.length)
        );
        context.fillText(this.text, this.x * this.fontSize, this.y * this.fontSize);
        if (this.y * this.fontSize > this.canvasHeight && Math.random() > 0.8) {
            this.y = 0;
        } else {
            this.y += 1;
        }
    }
}

class Effect {
    constructor(canvasWidth, canvasHeight) {
        this.canvasWidth = canvasWidth;
        this.canvasHeight = canvasHeight;
        this.fontSize = 18;
        this.columns = this.canvasWidth / this.fontSize;
        this.symbols = [];
        this.#initialize();

        console.log(this.symbols);
    }
    #initialize() {
        for (let i = 0; i < this.columns; i++) {
            this.symbols[i] = new Symbol(i, 0, this.fontSize, this.canvasHeight);
        }
    }
    resize(width, height) {
        this.canvasWidth = width;
        this.canvasHeight = height;
        this.columns = this.canvasHeight / this.fontSize;
        this.symbols = [];
        this.#initialize();
    }
}

this.effect = new Effect(canvas.width, canvas.height);
let lastTime = 0;
const fps = 60;
const nextFrame = 1000 / fps;
let timer = 0;

function animate(timeStamp) {
    const deltaTime = timeStamp - lastTime;
    lastTime = timeStamp;

    if (timer > nextFrame) {
        ctx.fillStyle = "rgba(0,0,0, 0.05)";
        ctx.textAlign = "center";
        ctx.fillRect(0, 0, canvas.width, canvas.height);
        ctx.fillStyle = gradient; //'#0aff0a';
        ctx.font = effect.fontSize + "px monospace";
        effect.symbols.forEach((symbol) => symbol.draw(ctx));

        timer = 0;
    } else {
        timer += deltaTime;
    }

    requestAnimationFrame(animate);
}
animate(0);

window.addEventListener("resize", function () {
    canvas.width = window.innerWidth;
    canvas.height = window.innerHeight;
    effect.resize(canvas.width, canvas.height);

    gradient = ctx.createRadialGradient(
        canvas.width / 2,
        canvas.height / 2,
        100,
        canvas.width / 2,
        canvas.height / 2,
        canvas.width / 2
    );
    gradient.addColorStop(0, "white");
});
